#!/usr/bin/python
# -*- coding: latin-1 -*-

# ================================================= #
# All koden er skrevet av Kristin Krogh Arnesen,    #
# med unntak av metoden finn_invers() som er hentet #
# fra http://cobweb.ecn.purdue.edu/~kak/compsec/    #
# NewLectures/Lecture5.pdf og tilpasset av Kristin. #
#   Koden er dokumentert underveis, men det er ogs #
# skrevet en kort innfring i bruk av systemet  se #
# Vedlegg 1 i min masteroppgave.                    #
#   Trondheim, april 2010                           #
# ================================================= #


# =========================== #
# ENDELIG KROPP               #
# =========================== #
# Polynomringen vi befinner   #
# oss i er over en endelig    #
# kropp, med P antall elemen- #
# ter der P er et primtall.   #
# =========================== #

# ENDELIG KROPP
# P: global variabel som kalles av flere metoder
P = 31		#default antall elementer i kroppen


# ENDRE KROPP
# input: et PRIMTALL
def setKropp(val):
	global P
	P = val
	print 'kroppen har n ' + str(P) + ' elementer.'


# INVERSER I KROPPEN
# input: et element i kroppen (ikke 0)
# output: invers av inputen modulo P
def finn_inverse(a):
	global P
	if a < 0:
		a = a + P
	a1, a2 = 0, P
	b1, b2 = 1, a
	while b2 != 0:
		q = a2 // b2
		t = a1 - b1 * q, a2 - b2 * q
		a1, a2 = b1, b2
		b1, b2 = t
	if a2 != 1:
		print "Feil! Kroppen har ikke et gyldig antall elementer."
		return 0
	else:
		if a1 < 0: 
			a1 = a1 + P
		return a1


# =========================== #
# MONOMORDNING-KLASSER        #
# =========================== #
# Flgende ordninger er med:  #
#  - lengde-leksikografisk    #
#  - vekt-leksikografisk      #
#  - total                    #
# Superklasse: Ordning        #
# Vekt-leks. og total er sub- #
# klasser av lengde-leks.     #
#    I Ordning-klassen m det #
# deklareres en variabelliste #
# p formen [x1,...,xn]   #
# der x1 > ... > xn > 1.      #
# =========================== #

# SUPERKLASSE FOR ORDNINGER
class Ordning:
	
	def __init__(self,value):
		self.liste = value
	def setliste(self, value):
		self.liste = value


	# sorterer et polynom  bruker smlikn-metoden
	# MERK: "polynom" er ikke definert som klasse enda!
	# input: et tuppel ("polynom") p formen ([monom-liste],[koeffisient-liste])
	# output: et tilsvarende tuppel der listene er sortert etter valgt ordning (jf. subklassen)
	def sort(self,f):
		lengde = len(f[0])
		liste = ([],[])
		if lengde != 0 and lengde != 1:
			liste = self.merge(self.sort((f[0][(lengde//2):],f[1][(lengde//2):])), self.sort((f[0][:(lengde//2)],f[1][:(lengde//2)])))
	
			return liste
		else:
			return f

	def merge(self,f1,f2):

		global P
		len1 = len(f1[0])

		len2 = len(f2[0])
		i, j = 0,0
		R = []
		S = []
		while len1 > i and len2 > j:
			test = self.smlikn(f1[0][i],f2[0][j])
			if f1[0][i] == f2[0][j]	 :		#hvis monomene er like
				nykoeff = (f1[1][i]+f2[1][j]) % P
				if nykoeff != 0:		#hvis koeff ikke er null
					R.append(f1[0][i])
					if nykoeff <= abs(nykoeff-P):
						S.append(nykoeff) 
					else:
						S.append(nykoeff-P)
				i += 1
				j += 1
			elif test:				#hvis det frste er strst
				if f1[1][i] != 0:		#hvis koeff ikke er null
					R.append(f1[0][i])
					if f1[1][i] <= abs(f1[1][i]-P):
						S.append(f1[1][i]) 
					else:
						S.append(f1[1][i]-P)
				i += 1
			else:

				if f2[1][j] != 0:		#hvis koeff ikke er null
					R.append(f2[0][j]
)
					if f2[1][j] <= abs(f2[1][j]-P):
						S.append(f2[1][j]) 
					else:
						S.append(f2[1][j]-P)
				j += 1
		while len1 > i:
			if f1[1][i] != 0:
				R.append(f1[0][i])
				if f1[1][i] <= abs(f1[1][i]-P):
					S.append(f1[1][i]) 
				else:
					S.append(f1[1][i]-P)
			i += 1
		while len2 > j:
			if f2[1][j] != 0:		#hvis koeff ikke er null
				R.append(f2[0][j]
)
				if f2[1][j] <= abs(f2[1][j]-P):
					S.append(f2[1][j]) 
				else:
					S.append(f2[1][j]-P)
			j += 1		
		return R,S


# LENGDE-LEKSIKOGRAFISK ORDNING
class LenLex(Ordning):
	# lengde-lex med variabelrekkeflge lagret i LISTE i superklassen
	# input: variabellista [x1,...,xn] der x1 > ... > xn
	def __init__(self,value):
		Ordning.__init__(self,value)
		if self.liste[-1] != '1':
			self.liste.append('1')

	# skriver ut ordning og variabelliste
	def __repr__(self):
		val = ''
		for i in self.liste[:-1]:
			val = val + i + ' > '
		return 'Lengde-leksikografisk ordning med ' + val + self.liste[-1]

	# sammenlikn-metode for monomer
	# input: to monomer a og b
	# output: 1 hvis a er strst (eller ved likhet), 0 ellers
	def smlikn(self,a,b):
		if a == '1' and b != '1':
			return 0
		elif b == '1' and a != '1':
			return 1
		elif len(a)>len(b):
			return 1
		elif len(b)>len(a):
			return 0
		else: 
			for i in range(len(a)):
				if self.liste.index(a[i]) < self.liste.index(b[i]):
					return 1
				elif self.liste.index(a[i]) > self.liste.index(b[i]):
					return 0
			return 0
		


# VEKT-LEKSIKOGRAFISK ORDNING
class VektLex(LenLex):
	# vektene er lagret som en DICTIONARY p formen { 'x1': 3, 'x2': 4, ... }  trenger IKKE inneholde variabelen 1
		
	vektliste = None	#ingen default vektliste

	# input: vlist - vektlista
	#	 list - variabellista
	def __init__(self,vlist,list):
		LenLex.__init__(self,list)
		self.vektliste = vlist
		#forsikre at 1 er med og har vekt 0:
		self.vektliste['1'] = 0
	
	# skriver ut ordning, variabelliste og vektliste
	def __repr__(self):
		val = ''
		for i in self.liste[:-1]:
			val = val + i + ' > '
		return 'Vekt-leksikografisk ordning med ' + val + self.liste[-1] + ' og vekter ' + str(self.vektliste)

	# tverrsum-beregning
	# input: et monom a
	# output: tverrsummen (jf. vektlista)
	def tverrsum(self,a):
		sumA = 0
		for x in a:
			sumA = sumA + self.vektliste[x]
		return sumA

	# sammenlikn-metode for monomer
	# input: to monomer a og b
	# output: 1 hvis a er strst (eller ved likhet), 0 ellers
	def smlikn(self,a,b):
		sumA = self.tverrsum(a)
		sumB = self.tverrsum(b)
		if sumA > sumB:
			return 1
		elif sumB > sumA:
			return 0
		#hvis de har lik tverrsum, kjr lengde-lex:
		print "vi m bruke LenLex!"
		k = LenLex.smlikn(self,a,b)
		if k:
			return 1
		else:
			return 0


# TOTAL ORDNING
class Total(LenLex):
	# har kun variabelliste, som superklassen.
	# input: variabellista [x1,...,xn] der x1 > ... > xn
	def __init__(self,value):
		LenLex.__init__(self,value)

	# skriver ut ordning og variabelliste
	def __repr__(self):
		val = ''
		for i in self.liste[:-1]:
			val = val + i + ' > '
		return 'Total ordning med ' + val + self.liste[-1]
	
	# sammenlikn-metode for monomer
	# input: to monomer a og b
	# output: 1 hvis a er strst (eller ved likhet), 0 ellers
	def smlikn(self,a,b):
		#lage vektor basert p kommutativ versjon
		A = self.vektor(a)
		B = self.vektor(b)
		#sammenlikne
		for i in range(len(A)):
			if A[i] > B[i]:
				return 1
			elif B[i] > A[i]:
				return 0
		#hvis vektorene er like:
		print "vi m bruke LenLex!"
		k = LenLex.smlikn(self,a,b)
		if k:
			return 1
		else:
			return 0

	# vektor-metode som teller antall av hvert symbol (jf. kommutativ gradert leksikografisk ordning)
	# input: et monom a
	# output: en vektor [q1,q2,...,qn] der qi er antall av symbolet liste[i] som finnes i a
	def vektor(self,a):
		res = []
		for i in self.liste:
			res.append(a.count(i))
		return res
	

# SETTER EN ORDNING
ORD = LenLex(['x','y','z'])	#default ordning er lengde-leksikografisk med x > y > z

def setOrd(ordning):
	global ORD
	ORD = ordning



# =========================== #
# POLYNOMER                   #
# =========================== #
# Polynomer er implementert   #
# som klasser, der +,- og *   #
# tolkes direkte vha pythons  #
# innebygde egenskaper.       #
# =========================== #

# POLYNOMKLASSE
class Polynom:
	mon = []
	koeff = []
	
	# input: val1 - monomlista
	#	 val2 - koeffisientlista
	def __init__(self,val1,val2):
		global P	#koeffisientkroppen
		global ORD	#den tillatelige ordningen
		
		mon = []
		koff = []
		for i in range(len(val1)):
			x = val2[i] % P
			if x != 0:
				mon.append(val1[i])
				koff.append(val2[i])
		val1,val2 = ORD.sort((mon,koff))
		self.mon = val1
		self.koeff = val2

	# printer polynom
	# kalles av "print f" der f er Polynom
	# output: en pen og naturlig representasjon av polynomet
	def __str__(self):
		if not self.koeff:
			return '0'
		elif self.koeff[0] > 0:
			val = ''
		else:
			val = '-'
		for i in range(len(self.mon)-1):
			if self.koeff[i+1] > 0:
				val = val + str(abs(self.koeff[i])) + '*' + self.mon[i] + ' + '
			else:
				val = val + str(abs(self.koeff[i])) + '*' + self.mon[i] + ' - '
		val = val + str(abs(self.koeff[-1])) + '*' + self.mon[-1]
		return val

	# set-metoder
	def setmon(self,val):
		self.mon = val	
	def setkoeff(self,val):
		self.koeff = val

	# resortere polynomet (hvis man skifter ordning)
	def sorter(self):
		global ORD
		(a,b) = ORD.sort((self.mon,self.koeff))
		self.setmon(a)
		self.setkoeff(b)

	# tuppen av polynomet (som streng)
	def tip(self):
		return self.mon[0]

	# addisjon av polynomer
	# input: polynomet som skal legges til dette
	# output: et nytt Polynom-objekt som er summen
	def __add__(self,other):
		hm = (self.mon+other.mon,self.koeff+other.koeff)
		return Polynom(hm[0],hm[1])

	# subtraksjon av polynomer
	# input: polynomet som skal trekkes fra dette
	# output: et nytt Polynom-objekt som er differansen
	def __sub__(self,other):
		hm = []
		for i in other.koeff:
			hm.append(-1*i)
		h = Polynom(other.mon,hm)
		return self.__add__(h)

	# multiplikasjon av polynomer
	# input: polynomet som skal ganges med dette
	# output: et nyt Polynom-objekt som er produktet
	def __mul__(self,other):
		h = ([],[])
		for i in range(len(self.mon)):
			for j in range(len(other.mon)):
				m = self.mon[i]
				n = other.mon[j]
				if m != '1' and n != '1':
					h[0].append(m+n)

				elif m != '1' and n == '1':
					h[0].append(m)
				else:
					h[0].append(n)
				h[1].append(self.koeff[i]*other.koeff[j])
		return Polynom(h[0],h[1])

	# multiplisere med et tall
	# input: et element i P
	# gir ikke output, men endrer selve polynomet
	def mult_koeff(self,val):
		global P
		for i in range(len(self.koeff)):
			t = self.koeff[i]*val % P
			if t <= abs(t-P):
				self.koeff[i] = t
			else:
				self.koeff[i] = t - P

	# gjre polynomet monisk
	# gir ikke output, men endrer selve polynomet
	def monisk(self):
		global P
		a = finn_inverse(self.koeff[0])
		self.mult_koeff(a)


# BRUKERVENNLIG KONSTRUKSJON AV POLYNOMER
# input: en streng som '3*xy + 2*xx + -1*1', der
#	- ledd skilles med +
#	- koeffisienter og monomer skilles med *
#	- negative koeffisienter skrives med - foran, men ikke glem + mellom leddene
# output: et Polynom-objekt
def pol(str):
	mono = []
	koeffi = []
	for term in str.split('+'):
		mono.append(term.split('*')[1].strip())
		koeffi.append(int(term.split('*')[0]))
	return Polynom(mono,koeffi)


# DIVISJONSALGORITME
# input: f - et polynom
#	 F - en mengde av polynomer
# output: r = f modulo F og tupler (a,b) i en nstet liste
def divalg(f,F):
	h = Polynom(f.mon,f.koeff)	#kopierer f
	s = len(F)			#antall elementer i F
	AB = []				#initialiserer (a,b)-tuplene:
	for i in range(s):
		AB.append([])
	r = ([],[])			#resten er forelpig to tomme lister
	i = 0				#indeks i F

	while h.mon:
		t = h.tip().find(F[i].tip())
		if t > -1:
			a = h.tip()[:t] or '1'
			b = h.tip()[t+len(F[i].mon[0]):] or '1'
			koff = h.koeff[0]*finn_inverse(F[i].koeff[0]) % P
			AB[i].append((Polynom([a],[koff]),Polynom([b],[1])))
			h = h - AB[i][-1][0]*F[i]*AB[i][-1][1]
			i = 0
		elif i<(s-1):
			i += 1
		else:
			r[0].append(h.mon.pop(0))
			r[1].append(h.koeff.pop(0))
			i = 0
	
	return (Polynom(r[0],r[1]),AB)


# =========================== #
# BUCHBERGERS ALGORITME       #
# =========================== #
# Buchbergers algoritme og    #
# oppdater-metoden kommer til #
# slutt. Frst en rekke meto- #
# der for  finne blokkeringer#
# og overlappsrelasjoner.     #
#    For "manuell" versjon av #
# Buchbergers, se neste del.  #
# Den frste delen ("blokke-  #
# ringer og overlapper") er   #
# felles for begge versjonene.#
# =========================== #


#  #
# BLOKKERINGER OG OVERLAPPER  #
#  #

# FINNE VENSTRE OVERLAPPER MELLOM TO MONOMER
# input: to monomer (dvs. strenger) u og v
# output: en liste med alle (l,r) som er slik at l*u = v*r er en overlapp
def venstre_overlapper(u,v):
	RES = []
	s = min(len(u),len(v))
	for i in range(1,s+1):
		if u[:i] == v[-i:]:
				l = u[i:] or '1'
				r = v[:-i] or '1'
				RES.append((l,r))
	return RES


# FINNE HYRE OVERLAPPER MELLOM TO MONOMER
# input: to monomer (dvs. strenger) u og v
# output: en liste med alle (r,l) som er slik at u*r = l*v er en overlapp
def hoyre_overlapper(u,v):
	return venstre_overlapper(v,u)


# FINNE MIDT-OVERLAPPER MELLOM TO MONOMER
# input: to monomer (dvs. strenger) u og v, der u er lengre enn v
# output: dersom vi har overlapp u = a*v*b returneres en liste med alle (a,b)-tupler (bde a,b ulik 1)
def midt_overlapp(u,v):
	RES = []
	u2 = u[1:-1]
	s = len(v)
	t = len(u2)
	for i in range(0,t-s+1):
		if u2[i:i+s] == v:
			RES.append((u[0]+u2[:i], u2[i+s:]+u[-1]))
	return RES


# FINNE ALLE BLOKKERINGER MELLOM TO MONOMER
# input: to monomer u og v, der u har "hyere nummer" enn v; og to nummer i og j der u = tip(fi) og v = tip(fj)
# output: en liste med blokkeringer (l,u,r;lambda,v,rho) som inneholder alle mulige overlapper mellom u og v
def finn_blokkeringer(u,v,i,j):
	RES = []
	# blokkeringer p formen (l,i,1;1,j,rho)
	R2 = venstre_overlapper(u,v)
	for s in R2:
		RES.append((str(s[1]),i,'1','1',j,str(s[0])))
	# blokkeringer p formen (1,i,r;lambda,j,1)
	R1 = hoyre_overlapper(u,v)
	for r in R1:
		RES.append(('1',i,str(r[0]),str(r[1]),j,'1'))
	# midt-blokkeringer
	if len(u) > len(v):
		R3 = midt_overlapp(u,v)
		for t in R3:
			RES.append(('1',i,'1',str(t[0]),j,str(t[1])))
	elif len(v) > len(u):
		R3 = midt_overlapp(v,u)
		for t in R3:
			RES.append((str(t[0]),i,str(t[1]),'1',j,'1'))
	return RES


# FINNE SELV-OVERLAPPER
# input: et monom u og et nummer D
# output: en liste med blokkeringer (l,u,1;1,u,rho)
def finn_selvoverlapper(u,D):
	R = []
	s = min(len(u),len(u))
	for i in range(1,s):
		if u[:i] == u[-i:]:
				r = u[i:] or '1'
				l = u[:-i] or '1'
				R.append((r,l))
	RES = []
	for r in R:
		RES.append((str(r[1]),D,'1','1',D,str(r[0])))
	return RES


# BEREGNE ALLE OVERLAPPER MELLOM ET POLYNOM OG EN ENDELIG MENGDE
# input: en endelig mengde F og et Polynom f
# output: en liste med blokkeringer p formen (l,D,r;lambda,j,rho) der D er |F| og j <= D
# husk at selv-overlapper er med!
# husk at lister i Python er 0-indeksert!
def get_overlapper(F,f):
	D = len(F)
	O = []
	# selv-overlapper
	O = O + finn_selvoverlapper(f.tip(),D)
	# overlapper med tidligere polynomer
	for i in range(len(F)):
		O = O + finn_blokkeringer(f.tip(),F[i].tip(),D,i)
	return O


# KONVERTERE FRA BLOKKERING TIL POLYNOMER
# input: en blokkering (l,i,r;lambda,j,rho) i form av et 6-tuppel der l,r,lambda,rho er strenger og i,j er tall
# output: et 4-tuppel (L,R,LAMBDA,RHO) der alle elementene er Polynom-objekter
def blokkering_til_polynom(blokk):
	L = Polynom([blokk[0]],[1])
	R = Polynom([blokk[2]],[1])
	LAMBDA = Polynom([blokk[3]],[1])
	RHO = Polynom([blokk[5]],[1])
	return (L,R,LAMBDA,RHO)


# BEREGNE OVERLAPPSRELASJON
# input: to Polynom-objekter f og g med polynom-blokkering blokk=(l,r;lambda,rho)
# output: overlappsrelasjonen, i form av et Polynom-objekt
def overlappsrelasjon(f,g,blokk):
	global P
	a = finn_inverse(f.koeff[0])
	blokk[0].setkoeff(map((lambda x: x*a),blokk[0].koeff))
	h1 = blokk[0]*f*blokk[1]
	d = finn_inverse(g.koeff[0])
	blokk[2].setkoeff(map((lambda x: x*d),blokk[2].koeff))
	h2 = blokk[2]*g*blokk[3]
	h=h1-h2
	return h


#  #
# REDUNDANS-KRITERIER         #
#  #

# SJEKKE OM EN BLOKKERING DELER EN ANNEN (KRITERIUM NR EN)
# input: to blokkeringer b1 = (l1,i,r1;lambda1,j,rho1) og b2 = (l2,i,r2;lambda2,k,rho2) p listeform
# output: 1 dersom b1 deler b2
#	  0 hvis ikke
def blokkering_deler(b1,b2):
	l1 = b1[0]
	r1 = b1[2]
	l2 = b2[0]
	r2 = b2[2]
	if l2[len(l2)-len(l1):] == l1 or l1 == '1':
		if r2[:len(r1)] == r1 or r1 == '1':
			return 1
	return 0


# FJERNE REDUNTANTE ELEMENTER DEL 1 (del 2 gjres direkte i Oppdater)
# input: G - en forelpig Grbnerbasis
# 	 Q - en liste med blokkeringer som skal reduseres slik at alle blokkeringer som deles av en annen blokkering i Q taes ut
# output: oppdatert versjon av Q
# merk: denne algoritmen er satt som egen siden den er "lite intuitiv"  lese, da man m trikse litt for  klare  ta ut elementer
# av en liste samtidig som  den traverseres flere ganger.
def fjern_redundante(G,Q):
	s = 0
	t1 = 1
	t2 = 1
	while s < len(Q):
		t1 = 1
		t2 = 1
		for i in Q[:s]:
			if blokkering_deler(i,Q[s]):
				Q.pop(s)
				t1 = 0
				break
		for j in Q[s+1:]:
			if blokkering_deler(j,Q[s]):
				Q.pop(s)
				t2 = 0
				break
		if t1 and t2:
			s += 1
	return Q


# KRITERIUM NR TO
# input: en blokkeringer b = (l,i,r;lambda,j,rho), u = tip(fi) og et monom v = tip(fk)
# output: 1 dersom l*tip(fi)*r = w1*tip(fk)*w2 for monomer w1, w2 ulik 1
#  	    og dersom minst en av {l,r} og minst en av {lambda,rho} er 1
#	  0 hvis ikke
def kriterium_to(b,u,v):
	l = b[0]
	r = b[2]
	# sjekker at l,r,lambda,rho oppfyller kravene
	if '1' not in [l,r]:
		return 0
	if '1' not in [b[3],b[5]]:
		return 0
	# lager l*tip(fi)*r
	p = ''
	if v == '1':
		return 1
	if u == '1':
		return 0
	if l != '1':
		if r != '1':
			p = l + u + r # dette skal ikke g an vel.
		else:
			p = l + u
	else:
		if r != '1':
			p = u + r
		else:
			p = u #dette skal vel ikke kunne vre mulig???
	p2 = p[1:-1]
	s = len(v)
	t = len(p2)
	for i in range(0,t-s+1):
		if p2[i:i+s] == v:
			return 1
	return 0


#  #
# OPPDATER OG BUCHBERGERS     #
#  #

# OPPDATER-ALGORITMEN
# input: G - en forelpig Grbnerbasis
#	 Qgammel - en grunnmengde for G
#	 g - et element som skal legges til i G
# output: Q, grunnmengde for G U {g}
def oppdater(G,Qgammel,g):
	Q = Qgammel
	# tester om g gjr tidligere elementer i Q redundante (sjekker frst hvilke elementer kriteriet
# holder for - fjerner dem i neste for-lkke for  unng krll med indekser)
	R = []
	for i in range(len(Q)):
		if kriterium_to(Q[i],G[Q[i][1]].tip(),g.tip()):
			R.append(i)
	R.reverse()
	for r in R:
		Q.pop(r)
	# lager alle nye blokkeringer
	O = get_overlapper(G,g) # er allerede fri for overfldige selv-overlapper
	# ta ut redundante elementer fra O
	O = fjern_redundante(G,O)
	Q = Q + O
	return Q


# BUCHBERGERS ALGORITME
# input: F = [f1,...,fs] - en endelig mengde polynomer
# output: en endelig Grbnerbasis G = [g1,...,gt]
# merk: algoritmen stopper ikke dersom idealet <F> har uendelig Grbnerbasis (den er heller ikke garantert  stoppe hvis <F> har endelig Grbnerbasis)
def buchberger(F):
	# initialiserer G og Q
	G = []
	Q = oppdater(G,[],F[0])
	G.append(F[0])
	# bygger Q fra F
	for i in range(1,len(F)):
		Q = oppdater(G,Q,F[i])
		G.append(F[i])
	# vurderer et og et element i Q
	while Q:
		sigma = Q.pop(0)
		b = blokkering_til_polynom(sigma)
		c = overlappsrelasjon(G[sigma[1]],G[sigma[4]],b)
		r = divalg(c,G)
		if r[0].mon:
			r[0].monisk()
			Q = oppdater(G,Q,r[0])
			G.append(r[0])
	return G


# =========================== #
# MANUELL VERSJON             #
# =========================== #
# Der Buchbergers ikke kjrer #
# fra start til "slutt", men  #
# man reduserer en og en blok-#
# kering "manuelt".           #
#   Merk at flere av metodene #
# som kalles er fra forrige   #
# del.                        #
# =========================== #


# FJERNE REDUNTANTE ELEMENTER DEL 1 (del 2 gjres direkte i Oppdater)
# input: G - en forelpig Grbnerbasis
# 	 Q - en liste med blokkeringer som skal reduseres slik at alle blokkeringer som deles av en annen blokkering i Q taes ut
# output: oppdatert versjon av Q
# identisk med nonprint-versjonen, bortsett fra at den skriver ut de redundante blokkeringene
def fjern_redundante_print(G,Q):
	T = [] #liste over redundante blokkeringer
	s = 0
	t1 = 1
	t2 = 1
	while s < len(Q):
		t1 = 1
		t2 = 1
		for i in Q[:s]:
			if blokkering_deler(i,Q[s]):
				print Q[s]
				T.append(Q.pop(s))
				t1 = 0
				break
		for j in Q[s+1:]:
			if blokkering_deler(j,Q[s]):
				print Q[s]
				T.append(Q.pop(s))
				t2 = 0
				break
		if t1 and t2:
			s += 1
	if T:
		print 'redundante blant disse:'
		for t in T:
			print t
	return Q



# OPPDATER-ALGORITMEN
# input: G - en forelpig Grbnerbasis
#	 Qgammel - en grunnmengde for G
#	 g - et element som skal legges til i G
# output: Q, grunnmengde for G U {g}
# identisk som forrige versjon, men skriver ut det som skjer underveis
def oppdater_print(G,Qgammel,g):
	Q = Qgammel
	# tester om g gjr tidligere elementer i Q redundante (sjekker frst hvilke elementer kriteriet
	# holder for - fjerner dem i neste for-lkke for  unng krll med indekser)
	R = []
	for i in range(len(Q)):
		if kriterium_to(Q[i],G[Q[i][1]].tip(),g.tip()):
			R.append(i)
	R.reverse()
	if R:
		print 'vi tar da ut flgende elementer fra Q:'
	for r in R:
		print Q[r]
		Q.pop(r)
	# lager alle nye blokkeringer
	O = get_overlapper(G,g) # er allerede fri for overfldige selv-overlapper
	print 'blokkeringene for dette elementet er: '
	if O:
		for o in O:
			print o
	else:
		print 'ingen'
	# ta ut redundante elementer fra O
	O = fjern_redundante_print(G,O)
	Q = Q + O
	return Q


# INITIALISERING FOR BUCHBERGERS
# beregner alle overlapper i mengden F (reduserer dem ikke!)
# input: en tuppredusert mengde F
# output: en liste (k) med overlappsrelasjonene fra mengden, Q
def init_buchberger(F):
	G = []
	print 'Kjrer Buchbergers algoritme. Initialiserer G ...'
	print 'lagt til som element nr. ' + str(len(G)) + ' i G:'
	print F[0]
	Q = oppdater_print(G,[],F[0])
	G.append(F[0])
	# bygger Q fra F
	for i in range(1,len(F)):
		print ''
		print 'lagt til som element nr. ' + str(len(G)) + ' i G:'
		print F[i]
		Q = oppdater_print(G,Q,F[i])
		G.append(F[i])
	return Q



# 1-STEG-I-GANGEN-BUCHBERGER
# input: G  en forelpig Grbnerbasis
# 	 Q  en liste blokkeringer
# output: (G,Q) - (ny forelpig Grbnerbasis, oppdatert k)
# tar ut frste blokkering i ken, reduserer modulo G.
# dersom svaret er ulik 0, legges det til i G
# finner blokkeringer mellom det nye elementet og G, og legger til i Q.
def pop_ko(G,Q):
	if Q:
		sigma = Q.pop(0)
		print 'vi velger ' + str(sigma) + ' fra Q'
		b = blokkering_til_polynom(sigma)
		c = overlappsrelasjon(G[sigma[1]],G[sigma[4]],b)
		r = divalg(c,G)
		print 'overlappsrelasjonen reduserte til ' + str(r[0])
		if r[0].mon:
			r[0].monisk()
			print 'lagt til som element nr. ' + str(len(G)) + ' i G:'
			print r[0]
			Q = oppdater_print(G,Q,r[0])
			G.append(r[0])
	else:
		print "Q er tom"
	return (G,Q)
